%{?_with_spoofsource:%define spoofsource 1}

%define _sbindir /sbin
%define _localstatedir /var/lib/syslog-ng

Name: syslog-ng
Version: 2.1.4
Release: 6.1
Summary: Next-generation syslog server

Group: System Environment/Daemons
License: GPLv2+
Url: http://www.balabit.com/products/syslog_ng/
Source0: http://www.balabit.com/downloads/files/syslog-ng/sources/2.0/src/%{name}-%{version}.tar.gz
Source1: syslog-ng.conf
Source2: syslog-ng.init.d
Source10: sysklogd-syslog-ng.sysconfig
Source11: sysklogd-1.4.1-logrotate.d-syslog.log
Source12: sysklogd-1.4.1-44-logrotate.d-syslog.log
Source20: rsyslog-syslog-ng.sysconfig
Source21: rsyslog-3.14.1-logrotate.d-rsyslog.log
##Patch1:   syslog-ng-cfg-lex.patch
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires: eventlog-devel >= 0.2.7-1
BuildRequires: flex
BuildRequires: byacc
BuildRequires: pkgconfig
BuildRequires: glib2-devel
BuildRequires: which
%if 0%{?centos_version} || 0%{?rhel_version} < 600
BuildRequires: tcp_wrappers
%else
BuildRequires: tcp_wrappers-devel
%endif
BuildRequires: libnet-devel
Requires: logrotate
Requires(post): /sbin/chkconfig
Requires(preun): /sbin/chkconfig
Requires(preun): /sbin/service
Requires(postun): /sbin/service
Provides: syslog
# merge separate syslog-vim package into one
Provides: syslog-ng-vim = %{version}-%{release}
Obsoletes: syslog-ng-vim < 2.0.8-1

%if 0%{?rhel_version} < 5 || 0%{?centos_version} < 5
%define sysconfig_src %{SOURCE10}
%define logrotated_src %{SOURCE11}
%define logrotated_dst syslog
Conflicts: sysklogd
%endif
%if 0%{?rhel_version} >= 5 || 0%{?centos_version} >= 5
%define sysconfig_src %{SOURCE10}
%define logrotated_src %{SOURCE12}
%define logrotated_dst syslog
Conflicts: sysklogd
%endif
%if 0%{?fedora_version} <= 7
%define sysconfig_src %{SOURCE10}
%define logrotated_src %{SOURCE11}
%define logrotated_dst syslog
%endif
%if 0%{?fedora_version} >= 8
%define sysconfig_src %{SOURCE20}
%define logrotated_src %{SOURCE21}
%define logrotated_dst rsyslog
%endif

%description
syslog-ng, as the name shows, is a syslogd replacement, but with new 
functionality for the new generation. The original syslogd allows 
messages only to be sorted based on priority/facility pairs; syslog-ng 
adds the possibility to filter based on message contents using regular 
expressions. The new configuration scheme is intuitive and powerful. 
Forwarding logs over TCP and remembering all forwarding hops makes it 
ideal for firewalled environments.


%prep
%setup -q
##%patch1

# force regeneration to avoid broken paths from upstream (#265221)
touch src/cfg-grammar.y


%build
%configure \
	--enable-ipv6 \
	--sysconfdir=%{_sysconfdir}/%{name} \
	--enable-tcp-wrapper \
%if 0%{?spoofsource}
	--enable-spoof-source \
%endif
	--enable-dynamic-linking || cat config.log
%__make || cat config.log


%install
%{__rm} -rf %{buildroot}
make DESTDIR=%{buildroot} install

%{__install} -d -m 755 %{buildroot}%{_sysconfdir}/%{name}
%{__install} -p -m 644 %{SOURCE1} %{buildroot}%{_sysconfdir}/%{name}/syslog-ng.conf

%{__install} -d -m 755 %{buildroot}%{_sysconfdir}/init.d
%{__install} -p -m 755 %{SOURCE2} %{buildroot}%{_sysconfdir}/init.d/%{name}

%{__install} -d -m 755 %{buildroot}%{_sysconfdir}/sysconfig
%{__install} -p -m 644 %{sysconfig_src} %{buildroot}%{_sysconfdir}/sysconfig/%{name}

%{__install} -d -m 755 %{buildroot}%{_sysconfdir}/logrotate.d
%{__install} -p -m 644 %{logrotated_src} \
	%{buildroot}%{_sysconfdir}/logrotate.d/%{logrotated_dst}

# make local state dir
%{__install} -d -m 755 %{buildroot}/%{_localstatedir}

# fix authors file
/usr/bin/iconv -f iso8859-1 -t utf-8 AUTHORS > AUTHORS.conv && \
	%{__mv} -f AUTHORS.conv AUTHORS

# fix executable perms on contrib files
%{__chmod} -x contrib/relogger.pl
%{__chmod} -x contrib/syslog2ng

# fix script interpreter
sed -i 's/\/usr\/local\/bin\/perl/\/usr\/bin\/perl/' contrib/relogger.pl

# install vim files
%{__install} -d -m 755 %{buildroot}%{_datadir}/%{name}
%{__install} -p -m 644 contrib/syslog-ng.vim %{buildroot}%{_datadir}/%{name}
for vimver in 63 64 70 71 ; do
	%{__install} -d -m 755 %{buildroot}%{_datadir}/vim/vim$vimver/syntax
	cd %{buildroot}%{_datadir}/vim/vim$vimver/syntax
	ln -s ../../../%{name}/syslog-ng.vim .
	cd -
done


%clean
rm -rf %{buildroot}


%post
/sbin/chkconfig --add %{name}
/sbin/service %{name} restart || :

%preun
if [ "$1" = 0 ]; then
	/sbin/service %{name} stop > /dev/null 2>&1
	/sbin/chkconfig --del %{name}
fi


%postun
if [ "$1" -ge 1 ]; then
	/sbin/service %{name} condrestart >/dev/null 2>&1
fi


%triggerin -- vim-common
VIMVERNEW=`rpm -q --qf='%%{epoch}:%%{version}\n' vim-common | sort | tail -n 1 | sed -e 's/[0-9]*://' | sed -e 's/\.[0-9]*$//' | sed -e 's/\.//'`
[ -d %{_datadir}/vim/vim${VIMVERNEW}/syntax ] && \
	cd %{_datadir}/vim/vim${VIMVERNEW}/syntax && \
	ln -sf ../../../%{name}/syslog-ng.vim . || :

%triggerun -- vim-common
VIMVEROLD=`rpm -q --qf='%%{epoch}:%%{version}\n' vim-common | sort | head -n 1 | sed -e 's/[0-9]*://' | sed -e 's/\.[0-9]*$//' | sed -e 's/\.//'`
[ $2 = 0 ] && rm -f %{_datadir}/vim/vim${VIMVEROLD}/syntax/syslog-ng.vim || :

%triggerpostun -- vim-common
VIMVEROLD=`rpm -q --qf='%%{epoch}:%%{version}\n' vim-common | sort | head -n 1 | sed -e 's/[0-9]*://' | sed -e 's/\.[0-9]*$//' | sed -e 's/\.//'`
VIMVERNEW=`rpm -q --qf='%%{epoch}:%%{version}\n' vim-common | sort | tail -n 1 | sed -e 's/[0-9]*://' | sed -e 's/\.[0-9]*$//' | sed -e 's/\.//'`
if [ $1 = 1 ]; then
	rm -f %{_datadir}/vim/vim${VIMVEROLD}/syntax/syslog-ng.vim || :
	[ -d %{_datadir}/vim/vim${VIMVERNEW}/syntax ] && \
		cd %{_datadir}/vim/vim${VIMVERNEW}/syntax && \
		ln -sf ../../../%{name}/syslog-ng.vim . || :
fi



%files
%defattr(-,root,root)
%doc AUTHORS COPYING README ChangeLog NEWS
%doc doc/reference/syslog-ng.txt
%doc doc/security/*.txt
%doc doc/examples/syslog-ng.conf.sample
%doc contrib/{relogger.pl,syslog2ng,syslog-ng.conf.doc}
%dir %{_sysconfdir}/%{name}
%config(noreplace) %{_sysconfdir}/%{name}/%{name}.conf
%config(noreplace) %{_sysconfdir}/sysconfig/%{name}
%config(noreplace) %{_sysconfdir}/logrotate.d/%{logrotated_dst}
%{_sysconfdir}/init.d/%{name}
%dir %{_localstatedir}
%{_sbindir}/%{name}
%{_bindir}/loggen
%{_datadir}/%{name}
%{_mandir}/man5/*
%{_mandir}/man8/*
%ghost %{_datadir}/vim/


%changelog
* Wed Sep 23 2008 Douglas E. Warner <silfreed@silfreed.net> 2.1.1-1
- update to 2.1.1
- fixing rsyslog logrotate compatibility
- removing versioned provides of sysklogd

* Thu Aug 28 2008 Douglas E. Warner <silfreed@silfreed.net> 2.0.9-4
- updated sysklogd logrotate script for rhel5

* Fri May 09 2008 Douglas E. Warner <silfreed@silfreed.net> 2.0.9-3
- fixing errors with init script
- added conditional tcp_wrappers/tcp_wrappers-devel BuildRequires

* Mon Apr 21 2008 Douglas E. Warner <silfreed@silfreed.net> 2.0.9-2
- include tcp-wrapper support
- include optional spoof-source support

* Wed Mar 26 2008 Douglas E. Warner <silfreed@silfreed.net> 2.0.9-1
- upgrade to 2.0.9
- update eventlog-devel BR to be 0.2.7
- add conditional builds for rhel, fedora <=7, fedora >= 8 to use
  rsyslog or sysklogd logrotate.d and pid files to avoid conflicting
  when installed

* Mon Mar 03 2008 Douglas E. Warner <silfreed@silfreed.net> 2.0.8-2
- moving syslog-ng config file to subdirectory
- moving localstatedir to /var/lib
- making default syslog-ng.conf file more friendly
- cleaning up init script

* Tue Feb 19 2008 Douglas E. Warner <silfreed@silfreed.net> 2.0.8-1
- upgrade to 2.0.8
- cleanup for fedora
- merging vim syntax file into main package and using JPO's install method

* Tue Jul 31 2007 Douglas E. Warner <silfreed@silfreed.net> 2.0.5-1
- upgrade to 2.0.5
- added ipv6 support to vim config file
- fixed macro in changelog
- fixed installed permission on init script
- fixed perms on localstatedir

* Sat May 19 2007 Douglas E. Warner <silfreed@silfreed.net> 2.0.4-1
- upgrade to 2.0.4

* Mon Mar 26 2007 Douglas E. Warner <silfreed@silfreed.net> 2.0.3-2
- setting localstatedir to /var/state/syslog-ng so that the syslog-ng.persist
  file is stored in a better place than /var

* Mon Mar 26 2007 Douglas E. Warner <silfreed@silfreed.net> 2.0.3-1
- upgrade to 2.0.3
- added BuildRequires for libnet

* Mon Nov 06 2006 Douglas E. Warner <silfreed@silfreed.net> 2.0.0-1
- upgrade to 2.0.0
- new Requires: eventlog and BuildRequires: eventlog-devel
- added BuildRequires: pkgconfig, bison, gcc-c++, glib2-devel
- config file moved from /etc/syslog-ng/syslog-ng.conf to /etc/syslog-ng.conf
- updated init.d script to pass in path to syslog-ng.conf file
- updated configure script to dynamically compile everything in

* Sun Oct 29 2006 Douglas E. Warner <silfreed@silfreed.net> 1.6.11-4
- Fixing Provides: sysklogd = 1.4.1

* Fri Oct 27 2006 Douglas E. Warner <silfreed@silfreed.net> 1.6.11-3
- Added post-uninstall script to conditionally restart the service
- Updated pre/post scripts to use name macro instead of syslog-ng
- Corrected changelog dates for 1.6.11-1 and 1.6.11-2

* Thu Oct 26 2006 Douglas E. Warner <silfreed@silfreed.net> 1.6.11-2
- Adding Provides: sysklogd-1.4.1 and sysklogd so that the vixie-cron
  dependancy is met

* Wed Oct 25 2006 Douglas E. Warner <silfreed@silfreed.net> 1.6.11-1
- upgrade to 1.6.11
- improvements to stock syslog-ng.conf suggested 
  by Peter Bieringer <pb@bieringer.de>
- improvements to init script suggested by Peter Bieringer <pb@bieringer.de>
- incorporated some changes from fedora-extras syslog-ng.conf
- removed comments from stock syslog-ng.conf - a changelog doesn't belong
  inside a config file
- removed Provides: sysklogd

* Tue Dec 27 2005 Douglas E. Warner <silfreed@silfreed.net> 1.6.9-2
- added BuildRequires: flex

* Wed Nov 23 2005 Douglas E. Warner <silfreed@silfreed.net> 1.6.9-1
- new version 1.6.9
- libol is included in source and is no longer requried for build or install

* Tue Jul 12 2005 Douglas E. Warner <silfreed@silfreed.net> 1.6.8-4
- send kernel messages to their own file

* Thu Jun 30 2005 Douglas E. Warner <silfreed@silfreed.net> 1.6.8-3
- fixing more errors reported by rpmlint

* Thu Jun 30 2005 Douglas E. Warner <silfreed@silfreed.net> 1.6.8-2
- enabled dynamic linking to libol
- fixing up errors reported by rpmlint

* Thu Jun 02 2005 Douglas E. Warner <silfreed@silfreed.net> 1.6.8-1
- new version 1.6.8
- libol required to be 0.3.16

* Mon Apr 11 2005 Douglas E. Warner <silfreed@silfreed.net> 1.6.7-1
- new version 1.6.7

* Tue Mar 29 2005 Douglas E. Warner <silfreed@silfreed.net> 1.6.6-1
- new version 1.6.6
- making detection of vim version automatic

* Thu Oct  7 2004 Douglas E. Warner <silfreed@silfreed.net> 1.6.5-6
- removed the chkconfig-syslog stuff from post/preun

* Thu Sep  2 2004 Douglas E. Warner <silfreed@silfreed.net> 1.6.5-5
- I forgot the syslog-ng vim source file; fixed

* Wed Sep  1 2004 Douglas E. Warner <silfreed@silfreed.net> 1.6.5-4
- can't conflict w/ sysklogd and provide it

* Wed Sep  1 2004 Douglas E. Warner <silfreed@silfreed.net> 1.6.5-3
- adding syslog-ng logrotate.d config
- conflicting w/ sysklogd and providing that package

* Fri Aug 20 2004 Douglas E. Warner <silfreed@silfreed.net> 1.6.5-2
- improved vim support

* Fri Aug 20 2004 Douglas E. Warner <silfreed@silfreed.net> 1.6.5-1
- new package for fc2

* Thu Feb 27 2003 Richard E. Perlotto II <richard@perlotto.com> 1.6.0rc1-1
  - Updated for new version

* Mon Feb 17 2003 Richard E. Perlotto II <richard@perlotto.com> 1.5.26-1
  - Updated for new version

* Sun Dec 20 2002 Richard E. Perlotto II <richard@perlotto.com> 1.5.24-1
  - Updated for new version

* Sun Dec 13 2002 Richard E. Perlotto II <richard@perlotto.com> 1.5.23-2
  - Corrected the mass of errors that occured with rpmlint
  - Continue to clean up for the helpful hints on how to write to a database

* Sun Dec 08 2002 Richard E. Perlotto II <richard@perlotto.com> 1.5.23-1
  - Updated file with notes and PGP signatures

